- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ogre::SceneQuery Class Reference

A class for performing queries on a scene. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::SceneQuery:
[legend]

List of all members.

## Public Types
enum | WorldFragmentType { WFT_NONE, WFT_PLANE_BOUNDED_REGION, WFT_SINGLE_INTERSECTION, WFT_CUSTOM_GEOMETRY, WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...
## Public Member Functions
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.
virtual WorldFragmentType | getWorldFragmentType (void) const
| Gets the current world fragment types to be returned from the query.
virtual const std::set < WorldFragmentType > * | getSupportedWorldFragmentTypes (void) const
| Returns the types of world fragments this query supports.
## Protected Attributes
SceneManager * | mParentSceneMgr
uint32 | mQueryMask
uint32 | mQueryTypeMask
std::set < WorldFragmentType > | mSupportedWorldFragments
WorldFragmentType | mWorldFragmentType
## Classes
struct | WorldFragment
| Represents part of the world geometry that is a result of a SceneQuery. More...

## Detailed Description

A class for performing queries on a scene.

Remarks:
  This is an abstract class for performing a query on a scene, i.e. to retrieve a list of objects and/or world geometry sections which are potentially intersecting a given region. Note the use of the word 'potentially': the results of a scene query are generated based on bounding volumes, and as such are not correct at a triangle level; the user of the SceneQuery is expected to filter the results further if greater accuracy is required.

  Different SceneManagers will implement these queries in different ways to exploit their particular scene organisation, and thus will provide their own concrete subclasses. In fact, these subclasses will be derived from subclasses of this class rather than directly because there will be region-type classes in between.

  These queries could have just been implemented as methods on the SceneManager, however, they are wrapped up as objects to allow 'compilation' of queries if deemed appropriate by the implementation; i.e. each concrete subclass may precalculate information (such as fixed scene partitions involved in the query) to speed up the repeated use of the query.

  You should never try to create a SceneQuery object yourself, they should be created using the SceneManager interfaces for the type of query required, e.g. SceneManager::createSphereSceneQuery.

Definition at line 68 of file OgreSceneQuery.h.

## Member Enumeration Documentation

enum Ogre::SceneQuery::WorldFragmentType

This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries.

Not all these types will be supported by all SceneManagers; once the application has decided which SceneManager specialisation to use, it is expected that it will know which type of world geometry abstraction is available to it.

Enumerator:

  WFT_NONE | Return no world geometry hits at all.
  WFT_PLANE_BOUNDED_REGION | Return pointers to convex plane-bounded regions.
  WFT_SINGLE_INTERSECTION | Return a single intersection point (typically RaySceneQuery only).
  WFT_CUSTOM_GEOMETRY | Custom geometry as defined by the SceneManager.
  WFT_RENDER_OPERATION | General RenderOperation structure.

Definition at line 77 of file OgreSceneQuery.h.

## Constructor & Destructor Documentation

Ogre::SceneQuery::SceneQuery | ( | SceneManager * | mgr | ) |

Standard constructor, should be called by SceneManager.

virtual Ogre::SceneQuery::~SceneQuery | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void Ogre::SceneQuery::setQueryMask | ( | uint32 | mask | ) | `[virtual]`

Sets the mask for results of this query.

Remarks:
  This method allows you to set a 'mask' to limit the results of this query to certain types of result. The actual meaning of this value is up to the application; basically MovableObject instances will only be returned from this query if a bitwise AND operation between this mask value and the MovableObject::getQueryFlags value is non-zero. The application will have to decide what each of the bits means.

virtual uint32 Ogre::SceneQuery::getQueryMask | ( | void |  | ) | const`[virtual]`

Returns the current mask for this query.

virtual void Ogre::SceneQuery::setQueryTypeMask | ( | uint32 | mask | ) | `[virtual]`

Sets the type mask for results of this query.

Remarks:
  This method allows you to set a 'type mask' to limit the results of this query to certain types of objects. Whilst setQueryMask deals with flags set per instance of object, this method deals with setting a mask on flags set per type of object. Both may exclude an object from query results.

virtual uint32 Ogre::SceneQuery::getQueryTypeMask | ( | void |  | ) | const`[virtual]`

Returns the current mask for this query.

virtual void Ogre::SceneQuery::setWorldFragmentType | ( | enum WorldFragmentType | wft | ) | `[virtual]`

Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.

Remarks:
  The application receiving the world geometry is expected to know what to do with it; inevitably this means that the application must have knowledge of at least some of the structures used by the custom SceneManager.

  The default setting is WFT_NONE.

virtual WorldFragmentType Ogre::SceneQuery::getWorldFragmentType | ( | void |  | ) | const`[virtual]`

Gets the current world fragment types to be returned from the query.

virtual const std::set<WorldFragmentType>* Ogre::SceneQuery::getSupportedWorldFragmentTypes | ( | void |  | ) | const`[virtual]`

Returns the types of world fragments this query supports.

Definition at line 169 of file OgreSceneQuery.h.

## Member Data Documentation

SceneManager* Ogre::SceneQuery::mParentSceneMgr`[protected]`

Definition at line 117 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryMask`[protected]`

Definition at line 118 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryTypeMask`[protected]`

Definition at line 119 of file OgreSceneQuery.h.

std::set<WorldFragmentType> Ogre::SceneQuery::mSupportedWorldFragments`[protected]`

Definition at line 120 of file OgreSceneQuery.h.

WorldFragmentType Ogre::SceneQuery::mWorldFragmentType`[protected]`

Definition at line 121 of file OgreSceneQuery.h.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Mon Jun 16 12:53:25 2008